/**
 * Copyright (c) 2019-2021 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 * @author Ludovic Autin <ludovic.autin@gmail.com>
 */
import { StateAction } from '../../mol-state';
import { PluginContext } from '../../mol-plugin/context';
import { PluginStateObject as PSO } from '../../mol-plugin-state/objects';
import { ParamDefinition as PD } from '../../mol-util/param-definition';
import { CellPacking } from './data';
import { IngredientFiles } from './util';
import { Structure } from '../../mol-model/structure';
import { Task } from '../../mol-task';
import { Asset } from '../../mol-util/assets';
import { Color } from '../../mol-util/color';
export declare function createStructureFromCellPack(plugin: PluginContext, packing: CellPacking, baseUrl: string, ingredientFiles: IngredientFiles): Task<{
    structure: Structure;
    assets: Asset.Wrapper<import("../../mol-util/data-source").DataType>[];
    colors: Color[];
}>;
export declare const LoadCellPackModel: StateAction<PSO.Root, void, PD.Normalize<{
    source: PD.NamedParams<"InfluenzaModel2.json" | "blood_hiv_immature_inside.json" | "HIV_immature_model.json" | "Blood_HIV.json" | "HIV-1_0.1.6-8_mixed_radii_pdb.json" | "influenza_model1.json" | "ExosomeModel.json" | "MycoplasmaGenitalium.json", "id"> | PD.NamedParams<Asset.File | null, "file">;
    baseUrl: string;
    results: Asset.File | null;
    membrane: string;
    ingredients: Asset.File[] | null;
    preset: PD.Normalize<{
        traceOnly: any;
        representation: any;
    }>;
}>>;
