/**
 * Copyright (c) 2019-2021 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { CustomStructureProperty } from '../../mol-model-props/common/custom-structure-property';
import { ParamDefinition as PD } from '../../mol-util/param-definition';
import { Color } from '../../mol-util/color';
export declare type CellPackInfoValue = {
    packingsCount: number;
    packingIndex: number;
    colors?: Color[];
};
declare const CellPackInfoParams: {
    info: PD.Value<CellPackInfoValue>;
};
declare type CellPackInfoParams = PD.Values<typeof CellPackInfoParams>;
export declare const CellPackInfoProvider: CustomStructureProperty.Provider<typeof CellPackInfoParams, CellPackInfoValue>;
export {};
