/**
 * Copyright (c) 2018-2020 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { Column } from '../../../../mol-data/db';
export declare const mmCIF_residueId_schema: {
    label_comp_id: Column.Schema.Str;
    label_seq_id: Column.Schema.Int;
    pdbx_PDB_ins_code: Column.Schema.Str;
    label_asym_id: Column.Schema.Str;
    label_entity_id: Column.Schema.Str;
    auth_comp_id: Column.Schema.Str;
    auth_seq_id: Column.Schema.Int;
    auth_asym_id: Column.Schema.Str;
};
export declare const mmCIF_chemCompBond_schema: {
    /** Indicates if the bond entry was taken from the protonation variant dictionary */
    molstar_protonation_variant: Column.Schema.Str;
    atom_id_1: Column.Schema.Str;
    atom_id_2: Column.Schema.Str;
    comp_id: Column.Schema.Str;
    value_order: Column.Schema.Aliased<"sing" | "doub" | "trip" | "quad" | "arom" | "poly" | "delo" | "pi">;
    pdbx_ordinal: Column.Schema.Int;
    pdbx_stereo_config: Column.Schema.Aliased<"N" | "E" | "Z">;
    pdbx_aromatic_flag: Column.Schema.Aliased<"N" | "Y">;
};
/** Has `type` extended with 'Ion' and 'Lipid' */
export declare const mmCIF_chemComp_schema: {
    type: Column.Schema.Aliased<"other" | "D-peptide linking" | "L-peptide linking" | "D-peptide NH3 amino terminus" | "L-peptide NH3 amino terminus" | "D-peptide COOH carboxy terminus" | "L-peptide COOH carboxy terminus" | "DNA linking" | "RNA linking" | "L-RNA linking" | "L-DNA linking" | "DNA OH 5 prime terminus" | "RNA OH 5 prime terminus" | "DNA OH 3 prime terminus" | "RNA OH 3 prime terminus" | "D-saccharide, beta linking" | "D-saccharide, alpha linking" | "L-saccharide, beta linking" | "L-saccharide, alpha linking" | "L-saccharide" | "D-saccharide" | "saccharide" | "non-polymer" | "peptide linking" | "peptide-like" | "L-gamma-peptide, C-delta linking" | "D-gamma-peptide, C-delta linking" | "L-beta-peptide, C-gamma linking" | "D-beta-peptide, C-gamma linking" | "Ion" | "Lipid">;
    formula: Column.Schema.Str;
    formula_weight: Column.Schema.Float;
    id: Column.Schema.Str;
    mon_nstd_flag: Column.Schema.Aliased<"y" | "yes" | "no" | "n">;
    name: Column.Schema.Str;
    pdbx_synonyms: Column.Schema.List<string>;
};
export declare type mmCIF_chemComp_schema = typeof mmCIF_chemComp_schema;
