"use strict";
/**
 * Copyright (c) 2018-2022 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.fillGridDim = exports.getRegularGrid3dDelta = void 0;
var linear_algebra_1 = require("../linear-algebra");
var geometry_1 = require("../geometry");
function getRegularGrid3dDelta(_a) {
    var box = _a.box, dimensions = _a.dimensions;
    return linear_algebra_1.Vec3.div((0, linear_algebra_1.Vec3)(), geometry_1.Box3D.size((0, linear_algebra_1.Vec3)(), box), linear_algebra_1.Vec3.subScalar((0, linear_algebra_1.Vec3)(), dimensions, 1));
}
exports.getRegularGrid3dDelta = getRegularGrid3dDelta;
function fillGridDim(length, start, step) {
    var a = new Float32Array(length);
    for (var i = 0; i < a.length; i++) {
        a[i] = start + (step * i);
    }
    return a;
}
exports.fillGridDim = fillGridDim;
