"use strict";
/**
 * Copyright (c) 2017-2022 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.InterUnitBonds = exports.IntraUnitBonds = void 0;
var tslib_1 = require("tslib");
var graph_1 = require("../../../../../mol-math/graph");
var unit_1 = require("../../unit");
var inter_unit_graph_1 = require("../../../../../mol-math/graph/inter-unit-graph");
var IntraUnitBonds;
(function (IntraUnitBonds) {
    IntraUnitBonds.Empty = graph_1.IntAdjacencyGraph.create([], [], [], 0, { flags: [], order: [] });
})(IntraUnitBonds || (IntraUnitBonds = {}));
exports.IntraUnitBonds = IntraUnitBonds;
var InterUnitBonds = /** @class */ (function (_super) {
    tslib_1.__extends(InterUnitBonds, _super);
    function InterUnitBonds() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /** Get inter-unit bond given a bond-location */
    InterUnitBonds.prototype.getBondFromLocation = function (l) {
        return unit_1.Unit.isAtomic(l.aUnit) && unit_1.Unit.isAtomic(l.bUnit) ? this.getEdge(l.aIndex, l.aUnit.id, l.bIndex, l.bUnit.id) : undefined;
    };
    /** Get inter-unit bond index given a bond-location */
    InterUnitBonds.prototype.getBondIndexFromLocation = function (l) {
        return unit_1.Unit.isAtomic(l.aUnit) && unit_1.Unit.isAtomic(l.bUnit) ? this.getEdgeIndex(l.aIndex, l.aUnit.id, l.bIndex, l.bUnit.id) : -1;
    };
    return InterUnitBonds;
}(inter_unit_graph_1.InterUnitGraph));
exports.InterUnitBonds = InterUnitBonds;
(function (InterUnitBonds) {
    var UnitPairBonds = /** @class */ (function (_super) {
        tslib_1.__extends(UnitPairBonds, _super);
        function UnitPairBonds() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return UnitPairBonds;
    }(inter_unit_graph_1.InterUnitGraph.UnitPairEdges));
    InterUnitBonds.UnitPairBonds = UnitPairBonds;
})(InterUnitBonds || (InterUnitBonds = {}));
exports.InterUnitBonds = InterUnitBonds;
