/**
 * Copyright (c) 2021-2022 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 * @author Sebastian Bittrich <sebastian.bittrich@rcsb.org>
 */
import { MinimizeRmsd } from '../../../../mol-math/linear-algebra/3d/minimize-rmsd';
import { Structure } from '../structure';
export interface AlignmentResultEntry {
    transform: MinimizeRmsd.Result;
    pivot: number;
    other: number;
}
export interface AlignmentResult {
    entries: AlignmentResultEntry[];
    zeroOverlapPairs: [number, number][];
    failedPairs: [number, number][];
}
export declare function alignAndSuperposeWithSIFTSMapping(structures: Structure[], options?: {
    traceOnly?: boolean;
}): AlignmentResult;
