"use strict";
/**
 * Copyright (c) 2020-21 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.useBehavior = void 0;
var react_1 = require("react");
// eslint-disable-next-line
function useBehavior(s) {
    var _a = (0, react_1.useState)({}), next = _a[1];
    var current = (0, react_1.useRef)();
    current.current = s === null || s === void 0 ? void 0 : s.value;
    (0, react_1.useEffect)(function () {
        if (!s) {
            return;
        }
        var sub = s.subscribe(function (v) {
            if (current.current !== v)
                next({});
        });
        return function () { return sub.unsubscribe(); };
    }, [s]);
    return s === null || s === void 0 ? void 0 : s.value;
}
exports.useBehavior = useBehavior;
