"use strict";
/**
 * Copyright (c) 2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.Focus = exports.SetSnapshot = exports.Reset = exports.registerDefault = void 0;
var commands_1 = require("../../commands");
function registerDefault(ctx) {
    Reset(ctx);
    Focus(ctx);
    SetSnapshot(ctx);
}
exports.registerDefault = registerDefault;
function Reset(ctx) {
    commands_1.PluginCommands.Camera.Reset.subscribe(ctx, function (options) {
        ctx.managers.camera.reset(options === null || options === void 0 ? void 0 : options.snapshot, options === null || options === void 0 ? void 0 : options.durationMs);
    });
}
exports.Reset = Reset;
function SetSnapshot(ctx) {
    commands_1.PluginCommands.Camera.SetSnapshot.subscribe(ctx, function (_a) {
        var snapshot = _a.snapshot, durationMs = _a.durationMs;
        ctx.managers.camera.setSnapshot(snapshot, durationMs);
    });
}
exports.SetSnapshot = SetSnapshot;
function Focus(ctx) {
    commands_1.PluginCommands.Camera.Focus.subscribe(ctx, function (_a) {
        var center = _a.center, radius = _a.radius, durationMs = _a.durationMs;
        ctx.managers.camera.focusSphere({ center: center, radius: radius }, { durationMs: durationMs });
        ctx.events.canvas3d.settingsUpdated.next(void 0);
    });
}
exports.Focus = Focus;
