/**
 * Copyright (c) 2019-2021 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 * @author Ludovic Autin <ludovic.autin@gmail.com>
 */
import { PluginStateObject as PSO } from '../../mol-plugin-state/objects';
import { ParamDefinition as PD } from '../../mol-util/param-definition';
import { CellPack as _CellPack } from './data';
import { Asset } from '../../mol-util/assets';
import { Vec3 } from '../../mol-math/linear-algebra';
import { StateTransformer } from '../../mol-state';
export declare const DefaultCellPackBaseUrl = "https://raw.githubusercontent.com/mesoscope/cellPACK_data/master/cellPACK_database_1.1.0";
declare const CellPack_base: {
    new (data: _CellPack, props?: {
        label: string;
        description?: string | undefined;
    } | undefined): {
        id: import("../../mol-util/uuid").UUID;
        type: PSO.TypeInfo;
        label: string;
        description?: string | undefined;
        data: _CellPack;
    };
    type: PSO.TypeInfo;
    is(obj?: import("../../mol-state/object").StateObject<any, import("../../mol-state/object").StateObject.Type<any>> | undefined): obj is {
        id: import("../../mol-util/uuid").UUID;
        type: PSO.TypeInfo;
        label: string;
        description?: string | undefined;
        data: _CellPack;
    };
};
export declare class CellPack extends CellPack_base {
}
export { ParseCellPack };
declare type ParseCellPack = typeof ParseCellPack;
declare const ParseCellPack: StateTransformer<PSO.Format.Json, CellPack, PD.Normalize<{
    resultsFile: Asset.File | null;
    baseUrl: string;
}>>;
export { StructureFromCellpack };
declare type StructureFromCellpack = typeof ParseCellPack;
declare const StructureFromCellpack: StateTransformer<CellPack, PSO.Molecule.Structure, PD.Normalize<{
    packing: number;
    baseUrl: string;
    ingredientFiles: Asset.File[] | null;
}>>;
export { StructureFromAssemblies };
declare type StructureFromAssemblies = typeof StructureFromAssemblies;
declare const StructureFromAssemblies: StateTransformer<PSO.Molecule.Model, PSO.Molecule.Structure, PD.Normalize<{}>>;
export declare const CreateCompartmentSphere: StateTransformer<PSO.Root, PSO.Shape.Representation3D, PD.Normalize<{
    center: Vec3;
    radius: number;
    label: string;
}>>;
