/**
 * Copyright (c) 2019-2021 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 * @author Ludovic Autin <ludovic.autin@gmail.com>
 */
import { AssetManager, Asset } from '../../mol-util/assets';
import { Structure } from '../../mol-model/structure';
import { Vec3 } from '../../mol-math/linear-algebra';
import { PluginContext } from '../../mol-plugin/context';
export declare function parseCif(plugin: PluginContext, data: string | Uint8Array): Promise<import("../../mol-io/reader/cif").CifFile>;
export declare function parsePDBfile(plugin: PluginContext, data: string, id: string): Promise<import("../../mol-io/reader/pdb/schema").PdbFile>;
export declare function getFromPdb(plugin: PluginContext, pdbId: string, assetManager: AssetManager): Promise<{
    mmcif: import("../../mol-io/reader/cif").CifBlock;
    asset: Asset.Wrapper<"string" | "binary">;
}>;
export declare function getFromOPM(plugin: PluginContext, pdbId: string, assetManager: AssetManager): Promise<{
    pdb: import("../../mol-io/reader/pdb/schema").PdbFile;
    asset: Asset.Wrapper<"string">;
}>;
export declare function getFromCellPackDB(plugin: PluginContext, id: string, baseUrl: string, assetManager: AssetManager): Promise<{
    pdb: import("../../mol-io/reader/pdb/schema").PdbFile;
    asset: Asset.Wrapper<"string">;
} | {
    mmcif: import("../../mol-io/reader/cif").CifBlock;
    asset: Asset.Wrapper<"string" | "binary">;
}>;
export declare type IngredientFiles = {
    [name: string]: Asset.File;
};
export declare function getStructureMean(structure: Structure): Vec3;
export declare function getFloatValue(value: DataView, offset: number): number;
