/**
 * Copyright (c) 2018-2020 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author Michal Malý <michal.maly@ibt.cas.cz>
 * @author Jiří Černý <jiri.cerny@ibt.cas.cz>
 */
import { DataLocation } from '../../../mol-model/location';
import { StructureElement } from '../../../mol-model/structure';
export var ConfalPyramidsTypes;
(function (ConfalPyramidsTypes) {
    function Location(pyramid, isLower, structure, unit, element) {
        return DataLocation('pyramid', { pyramid: pyramid, isLower: isLower }, { structure: structure, unit: unit, element: element });
    }
    ConfalPyramidsTypes.Location = Location;
    function isLocation(x) {
        return !!x && x.kind === 'data-location' && x.tag === 'pyramid';
    }
    ConfalPyramidsTypes.isLocation = isLocation;
    function toElementLocation(location) {
        return StructureElement.Location.create(location.element.structure, location.element.unit, location.element.element);
    }
    ConfalPyramidsTypes.toElementLocation = toElementLocation;
})(ConfalPyramidsTypes || (ConfalPyramidsTypes = {}));
