/**
 * Copyright (c) 2017-2018 mol* contributors, licensed under MIT, See LICENSE file for more info.
 *
 * @author David Sehnal <david.sehnal@gmail.com>
 * @author Alexander Rose <alexander.rose@weirdbyte.de>
 */
import { CifWriter } from '../../../mol-io/writer/cif';
import { Structure } from '../structure';
import { Model } from '../model';
import { CustomPropertyDescriptor } from '../../custom-property';
export interface CifExportContext {
    structures: Structure[];
    firstModel: Model;
    cache: any;
}
export declare type CifExportCategoryInfo = [CifWriter.Category, any /** context */, CifWriter.Encoder.WriteCategoryOptions] | [CifWriter.Category, any /** context */];
export declare namespace CifExportContext {
    function create(structures: Structure | Structure[]): CifExportContext;
}
export declare const mmCIF_Export_Filters: {
    onlyPositions: CifWriter.Category.Filter;
};
declare type encode_mmCIF_categories_Params = {
    skipCategoryNames?: Set<string>;
    exportCtx?: CifExportContext;
    copyAllCategories?: boolean;
    customProperties?: CustomPropertyDescriptor[];
};
/** Doesn't start a data block */
export declare function encode_mmCIF_categories(encoder: CifWriter.Encoder, structures: Structure | Structure[], params?: encode_mmCIF_categories_Params): void;
declare function to_mmCIF(name: string, structure: Structure, asBinary?: boolean, params?: encode_mmCIF_categories_Params): string | Uint8Array;
export { to_mmCIF };
